/*=========================================================================
    BieAmp with ID3Tag Editor
        Copyright (c) 2000-2004 Iori Ayane

    MP3 Decoder originally Copyright (C) 1995-1997 Xing Technology
    Corp.  http://www.xingtech.com
=========================================================================*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include "win/win.h"
#include "win/other.h"
#include "define.h"
#include "common.h"

#include "ctagedit.h"


extern char *Genre[157];


//ޥɥ饤ѥ᡼طե饰ν
//defein bieamp-con.cpp
extern struct control_flag con_flag;



//---------------------------------------------------------
//ޥɥ饤ѥ᡼TagԽ
void CommandLineTagEdit(int argc,char *argv[],InputMP3 *im)
{
  InputInfo iinfo;
  char path[MAX_PATH];
  int ext;

  if(im == NULL || argv == NULL || argc < 2){
    return;
  }

  //¤Τ0Ŷ
  ZeroMemory(&iinfo,sizeof(InputInfo));

  GetTagInfoInParams(argc,argv,path,&iinfo);

  if(con_flag.no_message == false){
    if(iinfo.szGenre < 0 || iinfo.szGenre >= 157){
      iinfo.szGenre = 0;
    }
    printf("Path : %s\n",path);
    printf("Track : %s\n",iinfo.szTrackName);
    printf("Artist : %s\n",iinfo.szArtistName);
    printf("Album : %s\n",iinfo.szAlbumName);
    printf("Year : %s\n",iinfo.szYear);
    printf("Comment : %s\n",iinfo.szComment);
    printf("Genre : %d(%s)\n",iinfo.szGenre,Genre[iinfo.szGenre]);
  }

  im->ConvertCharSet(&iinfo,false,con_flag.convert_char);

  ext = CheckExt(path);
  if(ext == EXT_RMP){
    if(im->writeRIFFInfo(path,&iinfo) == false){
      fprintf(stderr,"EditTag : Don't write RIFF Info\n");
    }
  }else{
    if(im->writeLYRICSInfo(path,&iinfo) == false){
      fprintf(stderr,"EditTag : Don't write Lyrics Info\n");
    }
  }
  if(ext > EXT_NONE){
    if(im->writeID3v1Info(path,&iinfo) == false){
      fprintf(stderr,"EditTag : Don't write ID3Tag Info\n");
    }else{
      fprintf(stderr,"Written ID3Tag!\n");
    }
  }


}

//---------------------------------------------------------
// ѥ᡼饿򽦤
// ºݤΥǡϲΥåμˤ""ǰϤޤ
BOOL GetTagInfoInParams(int argc,char *argv[],char *path,InputInfo *pinfo)
{
  int i;
  
  if(pinfo == NULL || argv == NULL || argc < 2){
    return false;
  }

  for(i=1;i<argc;i++){
    switch(CheckTagEditFlag(argv[i])){
    case CTE_EDIT_MODE:
      strncpy(path,argv[i+1],MAX_PATH);
      break;
    case CTE_TRACK_NAME:
      strncpy(pinfo->szTrackName,argv[i+1],INFO_NAME_SIZE);
      break;
    case CTE_ARTIST_NAME:
      strncpy(pinfo->szArtistName,argv[i+1],INFO_NAME_SIZE);
      break;
    case CTE_ALBUM_NAME:
      strncpy(pinfo->szAlbumName,argv[i+1],INFO_NAME_SIZE);
      break;
    case CTE_YEAR:
      strncpy(pinfo->szYear,argv[i+1],4);
      break;
    case CTE_COMMENT:
      strncpy(pinfo->szComment,argv[i+1],INFO_NAME_SIZE);
      break;
    case CTE_GENRE:
      pinfo->szGenre = atoi(argv[i+1]);
      break;
    default:
      //åʤȤϲi++򤹤Ȥ᤮ʤΤǤɤ
      continue;
    }
    i++;
  }
  return true;
}


//---------------------------------------------------------
//åͤǤ
// -tr --trackname CTE_TRACK_NAME
// -ar --artistname CTE_ARTIST_NAME
// -al --albumname CTE_ALBUM_NAME
// -ye --year CTE_YEAR
// -co --comment CTE_COMMENT
// -ge --genre CTE_GENRE
int CheckTagEditFlag(char *param)
{
  //ǥåȥ⡼ɤΥåľϥե̾ΤᤳǤ⽦
  if(strcmp(param,"-ei") == 0 || strcmp(param,"--editid3tag") == 0){
    return CTE_EDIT_MODE;
  }

  if(strcmp(param,"-tr") == 0 || strcmp(param,"--trackname") == 0){
    return CTE_TRACK_NAME;
  }
  if(strcmp(param,"-ar") == 0 || strcmp(param,"--artistname") == 0){
    return CTE_ARTIST_NAME;
  }
  if(strcmp(param,"-al") == 0 || strcmp(param,"--albumname") == 0){
    return CTE_ALBUM_NAME;
  }
  if(strcmp(param,"-ye") == 0 || strcmp(param,"--year") == 0){
    return CTE_YEAR;
  }
  if(strcmp(param,"-co") == 0 || strcmp(param,"--comment") == 0){
    return CTE_COMMENT;
  }
  if(strcmp(param,"-ge") == 0 || strcmp(param,"--genre") == 0){
    return CTE_GENRE;
  }
  return CTE_NONE;
}
