/*=========================================================================
    InputMP3 Class
    for BieAmp with ID3Tag Editor
        Copyright (c) 2000-2004 Iori Ayane
      
    MP3 Decoder originally Copyright (C) 1995-1997 Xing Technology
    Corp.  http://www.xingtech.com
=========================================================================*/

#include <stdio.h>
#include <string.h>
//#include <windows.h>

#include "../win/win.h"
#include "../win/other.h"
#include "inputmp3.h"


#pragma pack(1)
struct ID3Tagv1 {
  BYTE	tag[3];
  BYTE	trackName[30];
  BYTE	artistName[30];
  BYTE	albumName[30];
  BYTE	year[4];
  BYTE	comment[30];
  BYTE	genre;
};//128Х
#pragma pack()

static void strcpyID3v1(char* pszDest, const char* pszSrc,int len);


#ifndef TAGEDIT_ONLY   //--------  start TAGEDIT_ONLY ----
BOOL InputMP3::readID3v1Info(InputInfo* pInfo)
{
  ID3Tagv1	tag;
  BOOL		result;
  DWORD		bytesRead;

  //եθ128ХȤɤ߹
  ::SetFilePointer(m_hFile, -(long)sizeof(tag), NULL, FILE_END);
  result = ::ReadFile(m_hFile, &tag, sizeof(tag), &bytesRead, NULL);
  if (!result || bytesRead != sizeof(tag)) {
    return false;
  }
  if (::memcmp(tag.tag, "TAG", 3) != 0) {
    return false;
  }
  m_dataSize -= sizeof(ID3Tagv1);
  ::strcpyID3v1(pInfo->szTrackName,  (char*)tag.trackName,30);
  ::strcpyID3v1(pInfo->szArtistName, (char*)tag.artistName,30);
  ::strcpyID3v1(pInfo->szAlbumName, (char*)tag.albumName,30);
  ::strcpyID3v1(pInfo->szYear, (char*)tag.year,4);
  ::strcpyID3v1(pInfo->szComment, (char*)tag.comment,30);
  pInfo->szGenre = (int)tag.genre;

  return true;
}
#endif  //---------  end TAGEDIT_ONLY --------------------


//ˤ륹ڡڤ
void strcpyID3v1(char* pszDest, const char* pszSrc,int len)
{
  char* p1;
  char* p2;

  ::memcpy(pszDest,  pszSrc,  len);

  p1 = pszDest;
  p2 = pszDest + len-1;

  for (; p2 > p1 && *p2 == ' '; p2 --) {}
  *(p2 + 1) = 0;

}

//С饤
BOOL InputMP3::readID3v1Info(FILE *pszFile,InputInfo* pInfo)
{
  ID3Tagv1	tag;
  BOOL		result;
  DWORD		bytesRead;

  //եθ128ХȤɤ߹
  ::SetFilePointer(pszFile, -(long)sizeof(tag), NULL, FILE_END);
  result = ::ReadFile(pszFile, &tag, sizeof(tag), &bytesRead, NULL);
  if (!result || bytesRead != sizeof(tag)) {
    return false;
  }
  if (::memcmp(tag.tag, "TAG", 3) != 0) {
    return false;
  }
//	m_dataSize -= sizeof(ID3Tagv1);
  ::strcpyID3v1(pInfo->szTrackName,  (char*)tag.trackName,30);
  ::strcpyID3v1(pInfo->szArtistName, (char*)tag.artistName,30);
  ::strcpyID3v1(pInfo->szAlbumName, (char*)tag.albumName,30);
  ::strcpyID3v1(pInfo->szYear, (char*)tag.year,4);
  ::strcpyID3v1(pInfo->szComment, (char*)tag.comment,30);
  pInfo->szGenre = (int)tag.genre;
  
  return true;
}

//С饤
BOOL InputMP3::readID3v1Info(char *path,InputInfo* pInfo)
{
  FILE *fp;

  if((fp = fopen(path,"r")) == NULL){
    return false;
  }

  if(readID3v1Info(fp,pInfo) == false){
    return false;
  }
  
  return true;
}

//////////////////////////////////////////////////////////////////
//ID3TagV1ν
BOOL InputMP3::writeID3v1Info(char *path,InputInfo *pInfo)
{
  FILE *m_hFile = NULL;
  ID3Tagv1	tag;
  DWORD		bytesRead;
  BOOL		result;


  m_hFile = ::CreateFile(path, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ,
			 NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
  if(m_hFile == NULL) {
    fprintf(stderr,"ե񤭹Ѥ˳ޤǤ\n");
    return false;
  }


  //ɤ
  //	m_dataSize = ::GetFileSize(m_hFile, NULL);
  //եθ128ХȤɤ߹
  ::SetFilePointer(m_hFile, -(long)sizeof(tag), NULL, FILE_END);
  result = ::ReadFile(m_hFile, &tag, sizeof(tag), &bytesRead, NULL);
  if(!result || bytesRead != sizeof(tag)) {
    fclose(m_hFile);
    return false;
  }

  //ե˽񤭹ॿΥԡ
  strcopy((char*)tag.trackName,pInfo->szTrackName,30);
  strcopy((char*)tag.artistName,pInfo->szArtistName,30);
  strcopy((char*)tag.albumName,pInfo->szAlbumName,30);
  strcopy((char*)tag.year,pInfo->szYear,4);
  strcopy((char*)tag.comment,pInfo->szComment,30);
  tag.genre = (BYTE)(pInfo->szGenre);
    
    
  if(::memcmp(tag.tag, "TAG", 3) != 0){
    //ɣĥʤ
    memcpy(tag.tag,"TAG",3);
    ::SetFilePointer(m_hFile, 0, NULL, FILE_END);
    ::WriteFile(m_hFile,&tag,sizeof(tag),&bytesRead,NULL);
  }else{
    //ɣĥ
    ::SetFilePointer(m_hFile, -(long)sizeof(tag), NULL, FILE_END);
    ::WriteFile(m_hFile,&tag,sizeof(tag),&bytesRead,NULL);
  }

  fclose(m_hFile);

  return true;
}

