/*=========================================================================
    InputMP3 Class
    for BieAmp with ID3Tag Editor
        Copyright (c) 2000-2004 Iori Ayane
      
    MP3 Decoder originally Copyright (C) 1995-1997 Xing Technology
    Corp.  http://www.xingtech.com
=========================================================================*/

//#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "../win/win.h"
#include "inputmp3.h"

#pragma pack(1)
struct ID3Tagv2 {
  BYTE	id3[3];
  BYTE	version;
  BYTE	revision;
  BYTE	flags;
  BYTE	size[4];
};
#pragma pack()

#ifndef TAGEDIT_ONLY   //--------  start TAGEDIT_ONLY ----
BOOL InputMP3::readID3v2Info(InputInfo* pInfo)
{
  ID3Tagv2	tag;
  BOOL		result;
  DWORD		bytesRead;
  BYTE		temp[4];

  //եƬꡢΥإåɤ߹
  ::SetFilePointer(m_hFile, 0, NULL, FILE_BEGIN);
  result = ::ReadFile(m_hFile, &tag, sizeof(tag), &bytesRead, NULL);
  if (!result || bytesRead != sizeof(tag)) {
    return false;
  }
  if (::memcmp(tag.id3, "ID3", 3) != 0) {
    return false;
  }
  //28ӥåȤοͤѴ
  temp[3] =   (BYTE)(tag.size[3] | ((tag.size[2] & 1) << 7));
  temp[2] = (BYTE)(((tag.size[2] >> 1) & 63) | ((tag.size[1] & 3) << 6));
  temp[1] = (BYTE)(((tag.size[1] >> 2) & 31) | ((tag.size[0] & 7) << 5));
  temp[0] = (BYTE)(((tag.size[0] >> 3) & 15));
  m_firstSync = temp[3] | ((DWORD)temp[2] << 8) | 
    ((DWORD)temp[1] << 16) | ((DWORD)temp[0] << 24) + 10;
  m_dataSize -= m_firstSync;

  return true;
}
#endif  //---------  end TAGEDIT_ONLY --------------------

//С饤
BOOL InputMP3::readID3v2Info(FILE *pszFile,InputInfo* pInfo,int *sync)
{
  ID3Tagv2	tag;
  BOOL		result;
  DWORD		bytesRead;
  BYTE		temp[4];

  *sync = 0;

  //եƬꡢΥإåɤ߹
  ::SetFilePointer(pszFile, 0, NULL, FILE_BEGIN);
  result = ::ReadFile(pszFile, &tag, sizeof(tag), &bytesRead, NULL);
  if (!result || bytesRead != sizeof(tag)) {
    return false;
  }
  if (::memcmp(tag.id3, "ID3", 3) != 0) {
    return false;
  }
  //28ӥåȤοͤѴ
  temp[3] =   (BYTE)(tag.size[3] | ((tag.size[2] & 1) << 7));
  temp[2] = (BYTE)(((tag.size[2] >> 1) & 63) | ((tag.size[1] & 3) << 6));
  temp[1] = (BYTE)(((tag.size[1] >> 2) & 31) | ((tag.size[0] & 7) << 5));
  temp[0] = (BYTE)(((tag.size[0] >> 3) & 15));
  *sync = temp[3] | ((DWORD)temp[2] << 8) |
    ((DWORD)temp[1] << 16) | ((DWORD)temp[0] << 24) + 10;
  //	m_dataSize -= m_firstSync;
  
  return true;
}
