/*=========================================================================
    BieAmp with ID3Tag Editor
        Copyright (c) 2000-2004 Iori Ayane

    MP3 Decoder originally Copyright (C) 1995-1997 Xing Technology
    Corp.  http://www.xingtech.com
=========================================================================*/

//---------------------------------------------------------------------------
#include <stdlib.h>
#include <stdio.h>
#include <string.h>


#include "../win/win.h"
#include "inputitemdb.h"

extern char* Genre[157];

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
TInputItemDB::TInputItemDB()
{
    PlayListItems = NULL;//(InputItem *)malloc(sizeof(InputItem));

    CurrentTrack = 0;
    Items = 0;
    Operation = false;
}
//---------------------------------------------------------------------------
TInputItemDB::~TInputItemDB()
{
}

//---------------------------------------------------------------------------
InputItem* TInputItemDB::AddItem(void)
{
    Items++;
//    CurrentTrack++;
    if(PlayListItems == NULL){
        PlayListItems = (InputItem *)malloc(sizeof(InputItem));
    }else{
        PlayListItems = (InputItem *)realloc(PlayListItems,sizeof(InputItem)*Items);
    }

    if(PlayListItems == NULL){
      //        ShowMessage("ΰ褬ݤǤޤ");
      fprintf(stderr,"ΰ褬ݤǤޤ");
        return NULL;
    }

    Operation = true;

    return (PlayListItems + Items -1);
}
//---------------------------------------------------------------------------
//ƥ
BOOL TInputItemDB::DelItem(int num)
{
    InputItem *item=NULL,*list;

    item = (InputItem *)malloc(sizeof(InputItem) * Items);
    memcpy(item,PlayListItems,sizeof(InputItem)*Items);
    Items--;
    PlayListItems = (InputItem *)realloc(PlayListItems,sizeof(InputItem)*Items);
    list = PlayListItems;
    for(int i=0;i<=Items;i++){
        if(i == (num-1)){
            item++;
            continue;
        }
        memcpy(list,item,sizeof(InputItem));
        list++;
        item++;
    }

    free(item);

    Operation = true;

    return false;
}
//---------------------------------------------------------------------------
//٤ƺ
BOOL TInputItemDB::ClearItem(void)
{
    CurrentTrack = 0;
    Items = 0;
//    PlayListItems = (InputItem *)realloc(PlayListItems,sizeof(InputItem));
    free(PlayListItems);
    PlayListItems = NULL;

    Operation = true;

    return true;
}

//---------------------------------------------------------------------------
int TInputItemDB::GetCurrentTrack(void)
{
    return CurrentTrack;
}
//---------------------------------------------------------------------------
int TInputItemDB::GetItemCount(void)
{
    return Items;
}
//---------------------------------------------------------------------------
InputItem* TInputItemDB::GetCurrentItem(void)
{
    if(PlayListItems == NULL){
        return NULL;
    }else{
        return (PlayListItems + CurrentTrack - 1);
    }    
}
//---------------------------------------------------------------------------
InputItem* TInputItemDB::GetItem(int num)
{
    if(PlayListItems == NULL || num < 1 || num > Items){
        return NULL;
    }else{
        return (PlayListItems + num - 1);
    }
}
//---------------------------------------------------------------------------
BOOL TInputItemDB::SetItem(InputItem *item,int num)
{
    if(PlayListItems == NULL || num < 1 || num > Items){
        return false;
    }else{
        memcpy((PlayListItems+num-1),item,sizeof(InputItem));
        return true;
    }
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
BOOL TInputItemDB::ExchangeItem(int dest,int src)
{
    InputItem *si,*di,*ti;
    int count = GetItemCount();

    if(src > count || src < 1 || dest > count || dest < 1 || count < 1){
        return false;
    }

    si = GetItem(src);    //򤵤Ƥ
    di = GetItem(dest);      //ؤ
    ti = (InputItem *)malloc(sizeof(InputItem));

    memcpy(ti,si,sizeof(InputItem));
    memcpy(si,di,sizeof(InputItem));
    memcpy(di,ti,sizeof(InputItem));


    free(ti);

    Operation = true;

    return true;
}
//---------------------------------------------------------------------------







//---------------------------------------------------------------------------
BOOL TInputItemDB::SetTrack(int num)
{
    if(num > 0 && num <= Items){
        CurrentTrack = num;
    }else{
        return false;
    }

    return true;
}
//---------------------------------------------------------------------------
BOOL TInputItemDB::SetNext(void)
{
    if(CurrentTrack < (Items)){
        CurrentTrack++;
        return true;
    }else{
        return false;
    }
}
//---------------------------------------------------------------------------
BOOL TInputItemDB::SetPrev(void)
{
    if(CurrentTrack > 1){
        CurrentTrack--;
        return true;
    }else{
        return false;
    }
}
//---------------------------------------------------------------------------
void TInputItemDB::ResetInputInfo(InputInfo *info)
{
    strcpy(info->szTrackName,"");
    strcpy(info->szArtistName,"");
    strcpy(info->szAlbumName,"");
    strcpy(info->szYear,"");
    strcpy(info->szComment,"");
    info->szGenre = 0;

    info->channels = 0;
	info->bitRate = 0;
	info->samplingRate = 0;
	info->totalSec = 0;

    info->version = 0;
    info->layer = 0;
    info->mode = 0;
    info->modeExtension = 0;
    info->copyright = 0;
    info->original = 0;
    info->emphasis = 0;

}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//ե륤եȤ򥽡ȡե̾
//mode = 0 : ե̾ʿǡ
//mode = 1 : ե̡̾
//mode = 2 : ƥ
//mode = 3 : Х
//mode = 4 : ȥ
//mode = 5 : 
//mode = 6 : ǯ
//mode = 7 : 
//
//turn = true : 
//turn = false : ߽
//---------------------------------------------------------------------------
void swap(InputItem *items,int i,int j);
void getString(InputItem *item,char *dest,int mode);

void TInputItemDB::SortFileInfo(InputItem *items,int num,int mode,BOOL turn)
{
    int i = 0,j = num-1;
    char test1[MAX_PATH],test2[MAX_PATH];


    if(items == NULL){
        return;
    }
    
    getString(items+(int)((num-1)/2),test2,mode);
    
    do{
        if(turn){
            getString(items+i,test1,mode);
            while(strcomp(test1,test2)<0){
                i++;
                getString(items+i,test1,mode);
            }
            getString(items+j,test1,mode);
            while(strcomp(test1,test2)>0){
                j--;
                getString(items+j,test1,mode);
            }
        }else{
            getString(items+i,test1,mode);
            while(strcomp(test1,test2)>0){
                i++;
                getString(items+i,test1,mode);
            }
            getString(items+j,test1,mode);
            while(strcomp(test1,test2)<0){
                j--;
                getString(items+j,test1,mode);
            }
        }

        if(i<j){
            swap(items,i,j);
        }
    }while(++i <= --j);

    if(i == (j+3)){
        i--;
        j++;
    }

    if(j > 1){
        SortFileInfo(items,j+1,mode,turn);
    }

    if(i < (num-1)){
        SortFileInfo(items+i,num-i,mode,turn);
    }

    Operation = true;


}

//֤
void swap(InputItem *items,int i,int j)
{
    InputItem temp;

    memcpy(&temp,(void *)(items + i),sizeof(InputItem));
    memcpy((items + i),(items + j),sizeof(InputItem));
    memcpy((items + j),&temp,sizeof(InputItem));
}

void getString(InputItem *item,char *dest,int mode)
{

    if(item == NULL){
        return;
    }
    
    switch(mode){
    case 0:
        sprintf(dest,"%010d\0",GetFileNumber(item->path));
        break;
    case 1:
        strcpy(dest,item->path);
        break;
    case 2:
        strcpy(dest,item->info.szArtistName);
        break;
    case 3:
        strcpy(dest,item->info.szAlbumName);
        break;
    case 4:
        strcpy(dest,item->info.szTrackName);
        if(*dest == 0){
	  GetFileName(dest,item->path);
	  //            strcpy(dest,GetFileName(item->path).c_str());
        }
        break;
    case 5:
        sprintf(dest,"%010d\0",item->info.totalSec);
        break;
    case 6:
        strcpy(dest,item->info.szYear);
        break;
    case 7:
      strcpy(dest,Genre[item->info.szGenre]);
        break;
    default:
        strcpy(dest,"-");
        break;
    }

    if(*dest == '\0'){
        strcpy(dest,"-");
    }

}


//
void TInputItemDB::SortSecond(int sepa_mode,int sort_mode,BOOL turn)
{
    int f,i,e;
    InputItem *fi,*bi;

    f=0;
    e=GetItemCount();
    for(i=1;i<=e;i++){
        if((fi = GetItem(i)) == NULL){
            break;
        }
        if((bi = GetItem(i+1)) == NULL){
            if(i == e){
                SortFileInfo(GetItem(1)+f,i-f,sort_mode,turn);
            }
            break;
        }
        switch(sepa_mode){
        case 2:
            if(strcmp(fi->info.szArtistName,bi->info.szArtistName) != 0){
                SortFileInfo(GetItem(1)+f,i-f,sort_mode,turn);
                f = i;
            }
            break;
        case 3:
            if(strcmp(fi->info.szAlbumName,bi->info.szAlbumName) != 0){
                SortFileInfo(GetItem(1)+f,i-f,sort_mode,turn);
                f = i;
            }
            break;
        case 6:
            if(strcmp(fi->info.szYear,bi->info.szYear) != 0){
                SortFileInfo(GetItem(1)+f,i-f,sort_mode,turn);
                f = i;
            }
            break;
        case 7:
	  if(strcmp(Genre[fi->info.szGenre],Genre[bi->info.szGenre]) != 0){
	    if(fi->info.szGenre != bi->info.szGenre){
	      SortFileInfo(GetItem(1)+f,i-f,sort_mode,turn);
	      f = i;
	    }
	  }
	  break;
        default:
	  return;
        }
    }
    if(f==0){
        SortFileInfo(GetItem(1),e-1,sort_mode,turn);
    }

    Operation = true;

}


//operation֤ͤ
BOOL TInputItemDB::GetOperation()
{
    BOOL temp = Operation;
    Operation = false;

    return temp;
}


//֤Υå
//֤꤬äTRUE
BOOL TInputItemDB::CheckDuplicate(char *path)
{
    char src[MAX_PATH],dest[MAX_PATH];
    InputItem *item = NULL;

    if(path == NULL){
        return false;
    }

    strcpy(src,path);
    strlwr_A(src);

    item = PlayListItems;
    for(int i=0;i<Items;i++){
        strcpy(dest,item->path);
        strlwr_A(dest);
        if(strcmp(dest,src) == 0){
            return true;
        }
        item++;
    }

    return false;
}

