/*=========================================================================
    InputMP3 Class
    for BieAmp with ID3Tag Editor
        Copyright (c) 2000-2004 Iori Ayane
      
    MP3 Decoder originally Copyright (C) 1995-1997 Xing Technology
    Corp.  http://www.xingtech.com
=========================================================================*/

#ifndef _INPUT_MP3_H_
#define _INPUT_MP3_H_

//ԽεǽΤߤȤʤ褦ˤ
// (̾ϥᥤեڤؤΤǤΤޤ)
//#define TAGEDIT_ONLY


#include "inputplugin.h"
#ifndef TAGEDIT_ONLY   //--------  start TAGEDIT_ONLY ----
#include "mpegdecode/mpegdecode.h"
#include "../output/outputaudio.h"
#endif  //---------  end TAGEDIT_ONLY --------------------

//#include "audiocd.h"


#define FORCC(A) (((A & 0xff) << 24) | ((A & 0xff00) << 8) | ((A & 0xff0000) >> 8) | ((A & 0xff000000) >> 24))

#define CANTOPENFILE      -1  // ե뤬ʤ
#define NOTRIFF				-2	// RIFFǤϤʤ
#define NOTWAVE				-3	// ǤWAVEǤϤʤ
#define NOTFMT				-4	// fmt󥯤ʤ
#define INVALIDSAMPLERATE	-5	// ץ졼 (1-192000Hz)
#define INVALIDCHANNEL		-6	// ݡȥͥ (1,2)
#define INVALIDBPS			-7	// ̻Ҳӥå (8,16,32)
#define NODATA				-8	// ǡ0ä
#define SIZEZERO			-9

#define INTELBYTEORDER	FALSE
#define MC68BYTEORDER	TRUE


#define INAM    0
#define IART    1
#define IPRD    2
#define ICMT    3

#define ICRD    4
#define IGNR    5
#define ICOP    6
#define IENG    7
#define ISRC    8
#define ISFT    9
#define IKEY    10
#define ITCH    11
#define ICMS    12
#define ILYC    13
#define IMED    14
#define IMP3    15
#define ISBJ    16

#define FT_NONE 0
#define FT_MPX  1
#define FT_WAV  2
#define FT_CDA  3

#define MSG_STOP 1
#define MSG_PLAY 2
#define MSG_PAUSE 3
#define MSG_RESTART 4
#define MSG_SEEK 5
#define MSG_SET_VOL 6
#define MSG_GET_VOL 7

#define MSG_FIN_CONTROL 100
#define MSG_SEND_TO_OTHER_PROCESS 999

#define IPC_KEY 11111


typedef struct {
  unsigned long riff;
  unsigned long size;
  unsigned long wave;
  unsigned long  fmt;
  unsigned long  fmtsize;
} RIFFHEAD;

typedef struct {
  unsigned long  name;
  unsigned long  size;
} CHUNK;


struct RIFFInfo{
  char *data[17];
};


#ifndef TAGEDIT_ONLY   //--------  start TAGEDIT_ONLY ----

//IPCå塼ѹ¤
struct msgbuffer{
  /* åƬϤʤ餺long intǤʤФʤʤ */
  long int type;
  char data[BUFSIZ];
};

//ͭѤι¤
struct shmbuffer{
  int state;
  int time;
  InputInfo info;
  struct shmvolume{
    int left;
    int right;
  }vol;
};
#endif  //---------  end TAGEDIT_ONLY --------------------


class InputMP3
{

#ifndef TAGEDIT_ONLY   //--------  start TAGEDIT_ONLY ----
 private:
  FILE *m_hFile;                     //оΤΥե
  MPEG_HEADER m_mpegHeader;         //MPEG Audioإå
  DECODE_INFO m_decodeInfo;         //ǥɾ
  DECODE_OPTION m_decodeOption;     //ǥɥץ
  int m_firstSync;                  //ǽƱإåΰ
  int m_dataSize;                   //MPEG Audioǡ
  int m_decodePos;                  //ǥɥ

  int m_shm_id;                 //ͭID
  struct shmbuffer *m_shared;           //ߤξ(ͭ)

  int m_state;			//ߤξ
  INPUTPROC m_pProc;			//Хåؿ
  int m_userData;			//Хåؿѥ᡼
  OutputAudio* m_pOutput;			//ѥץ饰


  //Ū˥ǥɥåɤǤȤʤ
  unsigned char *m_inputBuf;	//ϥХåե
  int m_inputSize;		//ϥХåե
  unsigned char *m_inputPtr;	//ϥݥ
  int m_inputBytes;		//̤ǥɥ
  int m_inputTrigger;		//ϥȥꥬ
  unsigned char *m_outputBuf;	//ϥХåե
  int m_outputSize;		//ϥХåե
  unsigned char *m_outputPtr;	//ϥݥ
  int m_outputBytes;		//ǥɺѤߥ
  int m_outputTrigger;	        //ϥȥꥬ

  int m_openFileType;         //ߤΥե뤬ʤˤ(mpx,wav,cda)
                                            // 0 ... None  (FT_NONE)
                                            // 1 ... MpX   (FT_MPX)
                                            // 2 ... wav   (FT_WAV)
                                            // 3 ... cda   (FT_CDA)
  //  int m_AudioTrackNum;    //ãĤΥȥåֹ

  //CD Audio
  //TAudioCD *audio;

#endif  //---------  end TAGEDIT_ONLY --------------------

 public:
  InputMP3();
  ~InputMP3();

 public:

#ifndef TAGEDIT_ONLY   //--------  start TAGEDIT_ONLY ----
  BOOL setCallback(INPUTPROC pProc, int userData);
  BOOL setOutput(OutputAudio* pOutput);

  BOOL open(const char* pszName, InputInfo* pInfo);
  BOOL close();

  int getState();
  //ߤξ
  //getStateؿǼǤ
  enum {
    STATE_STOP	= 0,
    STATE_PLAY	= 1,
    STATE_PAUSE	= 2,
  };

  BOOL getFileInfo(const char* pszName, InputInfo* pInfo);

  BOOL play();
  BOOL stop();
  BOOL pause();
  BOOL restart();
  BOOL seek(int time);
  BOOL setVolume(int left, int right);
  BOOL getVolume(int *left,int *right);
  BOOL setDecodeOption(int reduction,int convert,int freqLimit);
  BOOL getInputInfo(InputInfo *pInfo);
  int  getTime(void);
  BOOL getVersion(char ver[]);
  BOOL sendEvent(unsigned int msg, int lParam, int rParam);
  BOOL clearEvent(void);

  int checkCDInfo(char *drive);
#endif  //---------  end TAGEDIT_ONLY --------------------

  //եν
  BOOL writeID3v1Info(char *path,InputInfo* pInfo);
  BOOL writeRIFFInfo(char *path,InputInfo* pInfo);
  BOOL writeLYRICSInfo(char *path,InputInfo* pInfo);

  //ʸɤѴ
  BOOL ConvertCharSet(InputInfo *pInfo,BOOL reverse,int flag);

 private:

#ifndef TAGEDIT_ONLY   //--------  start TAGEDIT_ONLY ----
  //ե
  BOOL readRIFFInfo(InputInfo* pInfo);
  BOOL readID3v1Info(InputInfo* pInfo);
  BOOL readID3v2Info(InputInfo* pInfo);
  BOOL readLyricsInfo(InputInfo* pInfo);
#endif  //---------  end TAGEDIT_ONLY --------------------

  //եѤΥС饤
  BOOL readRIFFInfo(FILE *pszFile,InputInfo* pInfo);
  BOOL readID3v1Info(FILE *pszFile,InputInfo* pInfo);
  BOOL readID3v2Info(FILE *pszFile,InputInfo* pInfo,int *sync);
  BOOL readLyricsInfo(FILE *pszFile,InputInfo* pInfo);

  BOOL readID3v1Info(char *path,InputInfo* pInfo);

  //RIFFInfo򥳥ԡ
  void loadRMPInfo(FILE *pszFile,InputInfo* pInfo);
  void loadRMPInfo(FILE *pszFile,RIFFInfo* pInfo);


#ifndef TAGEDIT_ONLY   //--------  start TAGEDIT_ONLY ----
  void ThreadProc(void *arg);

  int decode();
  int playCD();   //ãĤʤ餹ؿ(decode)
  void handleEvent(struct msgbuffer msg);
  void actionStop(unsigned char wait);
  void actionPause();
  void actionRestart();
  void actionSeek(int sec);
  void setState(int state);
  
  ///////////////////////////////////////////////////
  WAVEFORMATEX wfx;
  DWORD startpos;		// dataϤΥե
  DWORD endpos;		// dataΥե
  DWORD datasize;		// PCMǡΥ
  DWORD datapos;		// ȥե
  unsigned char byteorder;		// ǡХȤ¤(Mac,68CPU)
  int WaveOpen(FILE *hFile,LPWAVEFORMATEX w); // = NULL );
  void GetWaveFormatEx( LPWAVEFORMATEX w );
  int DecodeWave(void *p_d, DWORD size );
#endif  //---------  end TAGEDIT_ONLY --------------------


};

#endif
