/*=========================================================================
    InputMP3 Class
    for BieAmp with ID3Tag Editor
        Copyright (c) 2000-2004 Iori Ayane
      
    MP3 Decoder originally Copyright (C) 1995-1997 Xing Technology
    Corp.  http://www.xingtech.com
=========================================================================*/

//#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "../win/win.h"
#include "inputmp3.h"


#pragma pack(1)
struct LyricsHeader{
  BYTE name[6];
  BYTE info[5];
  BYTE id[3];
  BYTE var[5];
  BYTE space[2];
};

struct LyricsData{
  BYTE name[3];
  BYTE size[5];
  BYTE *data;
};

struct LyricsFooter{
  BYTE size[6];
  BYTE name[6];
  BYTE var[1];
  BYTE space[2];
};

struct LyricsDataInfo{
  BYTE name[3];
  BYTE size[5];
};

#pragma pack()


void copyLyricsInfo(InputInfo *pInfo,LyricsData *lData);
void copyLyricsData(char *dest,char *src,int num);

int WriteTag(FILE *pszFile,char *id,char *data,int size);
int atoint(char *size);


BOOL InputMP3::readLyricsInfo(FILE *pszFile,InputInfo* pInfo)
{
  LyricsData lData;
  LyricsFooter lFooter;
  BOOL		result;
  DWORD		bytesRead;
  int lsize = 0,readsize=0,fsize=0;
  lData.data = NULL;

  /* եκǸ夫եåκǽޤǰưɤߤ */
  ::SetFilePointer(pszFile, -(128+15), NULL, FILE_END);
  result = ::ReadFile(pszFile, &lFooter, sizeof(lFooter), &bytesRead, NULL);
  if (!result || bytesRead != sizeof(lFooter)) {
    fprintf(stderr,"lyrics : Don't read footer!\n");
    return false;
  }

  if (memcmp(lFooter.name, "LYRICS", 6) != 0) {
    fprintf(stderr,"lyrics : Footer Name Error!\n");
    return false;
  }
  if (memcmp(lFooter.var, "2", 1) != 0) {
    fprintf(stderr,"lyrics : Footer version error!\n");
    return false;
  }
  if (memcmp(lFooter.space, "00", 2) != 0) {
    fprintf(stderr,"lyrics : Footer space Error\n");
    return false;
  }
  fsize = atoi((char *)lFooter.size);

  //    lData.data = (BYTE *)malloc(1);
  // κǽ˰ưƷ֤ɤߤ
  ::SetFilePointer(pszFile, -(fsize-5+9+128), NULL, FILE_END);
  do{
    bytesRead = 0;
    result = ::ReadFile(pszFile, &lData, 8, &bytesRead, NULL);
    if (!result || bytesRead != 8) {
      fprintf(stderr,"lyrics : Data read error.(1)\n");
      return false;
    }
    //    printf("lyrics : name=%s,size=%s\n",lData.name,lData.size);
    lsize = atoint((char *)lData.size);
    if(lsize > 0){
      lData.data = (BYTE *)malloc(lsize);
      if(lData.data == NULL){
	return false;
      }
      bytesRead = 0;
      result = ::ReadFile(pszFile,lData.data,lsize,&bytesRead,NULL);
      if(!result || bytesRead != lsize){
	fprintf(stderr,"lyrics : Data read error.(2)\n");
	fprintf(stderr,"lyrics : read=%d , lsize=%d\n",bytesRead,lsize);
	return false;
      }
      copyLyricsInfo(pInfo,&lData);
      
      if(lData.data != NULL){
	free(lData.data);
      }
    }
    readsize += 8+lsize;
  }while(readsize < (fsize - 21));
  
  
  return true;
}

void copyLyricsInfo(InputInfo *pInfo,LyricsData *lData)
{
  int size = atoint((char *)lData->size)+1;
  if(memcmp(lData->name,"INF",3) == 0){
    copyLyricsData(pInfo->szComment,(char *)lData->data,size);
  }else if(memcmp(lData->name,"EAL",3) == 0){
    copyLyricsData(pInfo->szAlbumName,(char *)lData->data,size);
  }else if(memcmp(lData->name,"EAR",3) == 0){
    copyLyricsData(pInfo->szArtistName,(char *)lData->data,size);
  }else if(memcmp(lData->name,"ETT",3) == 0){
    copyLyricsData(pInfo->szTrackName,(char *)lData->data,size);
  }
}

void copyLyricsData(char *dest,char *src,int num)
{
  if(num >= INFO_NAME_SIZE){
    ::memcpy(dest, src, num);
    dest[INFO_NAME_SIZE - 1] = 0;
  }else{
    ::memcpy(dest, src, num);
    dest[num-1] = 0;
  }

}


///////////////////////////////////////////////////////////////////////////
// ̣ζʾ񤭤
BOOL InputMP3::writeLYRICSInfo(char *path,InputInfo* pInfo)
{
  FILE *pszFile = NULL;

  LyricsData lData,nData[4];
  LyricsFooter lFooter;
  BOOL		result;
  DWORD		bytesRead;
  int lsize = 0,readsize=0,fsize=0;
  lData.data = NULL;
  char dsize[6];

  //ե򳫤
  pszFile = ::CreateFile(path, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ,
			 NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
  if(pszFile == NULL) {
    fprintf(stderr,"ե񤭹Ѥ˳ޤǤ\n");
    return false;
  }

  // եκǸ夫եåκǽޤǰưɤߤ
  // ơǤˣ̣󤬤뤫ɤå
  ::SetFilePointer(pszFile, -(128+15), NULL, FILE_END);
  result = ::ReadFile(pszFile, &lFooter, sizeof(lFooter), &bytesRead, NULL);
  if (!result || bytesRead != sizeof(lFooter)) {
    fclose(pszFile);
    fprintf(stderr,"lyrics : Not found lyrics\n");
    return false;
  }

  if(memcmp(lFooter.name, "LYRICS", 6) == 0
     && memcmp(lFooter.var, "2", 1) == 0
     && memcmp(lFooter.space, "00", 2) == 0){
    fsize = atoi((char *)lFooter.size);
  }else{
    fsize = -4;
  }

  // κǽ˰ư
  ::SetFilePointer(pszFile, -(fsize-5+9+128), NULL, FILE_END);

  // 򤷤ʤɤߤ
  for(int i=0;i<4;i++){
    nData[i].data = NULL;
    memcpy(nData[i].size,"00000",5);
  }
  if(fsize != -4){
    do{
      result = ::ReadFile(pszFile, &lData, 8, &bytesRead, NULL);
      if (!result || bytesRead != 8) {
	fclose(pszFile);
	return false;
      }
      lsize = atoint((char *)lData.size);
      if(lsize > 0){
	lData.data = (BYTE *)malloc(lsize);
	if(lData.data == NULL){	
	  fclose(pszFile);
	  return false;
	}
	::ReadFile(pszFile,lData.data,lsize,&bytesRead,NULL);
	if(!result || bytesRead != (DWORD)lsize){
	  fclose(pszFile);
	  return false;
	}
	if(memcmp(lData.name,"IND",3) == 0){
	  nData[0].data = (BYTE *)malloc(lsize+1);
	  memcpy(nData[0].size,lData.size,5);
	  copyLyricsData((char *)nData[0].data,(char *)lData.data,lsize+1);
	}else if(memcmp(lData.name,"LYR",3) == 0){
	  nData[1].data = (BYTE *)malloc(lsize+1);
	  memcpy(nData[1].size,lData.size,5);
	  copyLyricsData((char *)nData[1].data,(char *)lData.data,lsize+1);
	}else if(memcmp(lData.name,"AUT",3) == 0){
	  nData[2].data = (BYTE *)malloc(lsize+1);
	  memcpy(nData[2].size,lData.size,5);
	  copyLyricsData((char *)nData[2].data,(char *)lData.data,lsize+1);
	}else if(memcmp(lData.name,"IMG",3) == 0){
	  nData[3].data = (BYTE *)malloc(lsize+1);
	  memcpy(nData[3].size,lData.size,5);
	  copyLyricsData((char *)nData[3].data,(char *)lData.data,lsize+1);
	}
	if(lData.data != NULL){
	  free(lData.data);
	}
      }
      readsize += 8+lsize;
    }while(readsize < (fsize - 21));
  }
  
  // κǽ˰ư
  ::SetFilePointer(pszFile, -(fsize-5+9+128), NULL, FILE_END);

  // LyricsʤäΥإå񤭤
  if(fsize == -4){
    ::WriteFile(pszFile,(void *)("LYRICSBEGIN"),11,&bytesRead,(void *)NULL);
  }

  fsize = 5;
  fsize += 8+WriteTag(pszFile,"IND","00",2);
  fsize += 8+WriteTag(pszFile,"LYR",
		      (char *)nData[1].data,atoint((char *)nData[1].size));
  fsize += 8+WriteTag(pszFile,"INF",pInfo->szComment,strlen(pInfo->szComment));
  fsize += 8+WriteTag(pszFile,"AUT",
		      (char *)nData[2].data,atoint((char *)nData[2].size));
  fsize += 8+WriteTag(pszFile,"EAL",pInfo->szAlbumName,
		      strlen(pInfo->szAlbumName));
  fsize += 8+WriteTag(pszFile,"EAR",pInfo->szArtistName,
		      strlen(pInfo->szArtistName));
  fsize += 8+WriteTag(pszFile,"ETT",pInfo->szTrackName,
		      strlen(pInfo->szTrackName));
  fsize += 8+WriteTag(pszFile,"IMG",(char *)nData[3].data,
		      atoint((char *)nData[3].size));
  fsize += 6;

  sprintf(dsize,"%06d",fsize);
  ::WriteFile(pszFile,dsize,6,&bytesRead,NULL);
  ::WriteFile(pszFile,(void *)("LYRICS200"),9,&bytesRead,(void *)NULL);
  
  SetEndOfFile(pszFile);
  
  //ʤ󤬤äȤϤ
  for(int i=0;i<4;i++){
    if(nData[i].data != NULL){
      free(nData[i].data);
    }
  }
  

  fclose(pszFile);

  return true;
}

int WriteTag(FILE *pszFile,char *id,char *data,int size)
{
  char dsize[5];
  DWORD bytesRead=0;


  ::WriteFile(pszFile,id,3,&bytesRead,NULL);
  sprintf(dsize,"%05d",size);
  ::WriteFile(pszFile,dsize,5,&bytesRead,NULL);
  if(size == 0 || data == NULL){
    bytesRead = 0;
  }else{
    ::WriteFile(pszFile,data,size,&bytesRead,NULL);
  }

  return bytesRead;
}

//եå
int atoint(char *size)
{
  char stemp[6];
  
  memcpy(stemp,size,5);
  stemp[5] = '\0';

  return atoi(stemp);
}
