#include "bstream.h"
#include "sbt.h"
#include "mpegdecode.h"

extern MPEG_HEADER		gMpegHeader;
extern DECODE_OPTION	gDecOption;
extern DECODE_INFO		gDecInfo;

extern int nsb_limit;
extern float sample[2304];

extern int max_sb;
extern int stereo_sb;

extern SBT_FUNCTION sbt;
extern SBT_FUNCTION sbt_table[2][3][5];

/* by init */
static float look_c_valueL1[18];

/* work Layer1,2 */
extern int bat[4][16];	/* set by unpack_ba */
extern int ballo[64];	/* set by unpack_ba */
extern unsigned int samp_dispatch[66];	/* set by unpack_ba */
extern float c_value[64];	/* set by unpack_ba */

extern unsigned int sf_dispatch[66];	/* set by unpack_ba */
extern float sf_table[64];
extern float cs_factor[3][64];
extern const int look_joint[16];
//extern int look_joint[16];
//int look_joint[16];

static float *cs_factorL1 = cs_factor[0];
static int nbatL1 = 32;

static int bit_skip;
static const int bat_bit_masterL1[] =
{
	0, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16
};


static void unpack_baL1()
{
	int j;
	int nstereo;

	bit_skip = 0;
	nstereo = stereo_sb;

	for (j = 0; j < nbatL1; j++)
	{
		bitget_check(4);
		ballo[j] = samp_dispatch[j] = mac_bitget(4);
		if (j >= nsb_limit)
			bit_skip += bat_bit_masterL1[samp_dispatch[j]];
		c_value[j] = look_c_valueL1[samp_dispatch[j]];
		if (--nstereo < 0)
		{
			ballo[j + 1] = ballo[j];
			/* flag as joint */
			samp_dispatch[j] += 15;
			/* flag for sf */
			samp_dispatch[j + 1] = samp_dispatch[j];
			c_value[j + 1] = c_value[j];
			j++;
		}
	}
/*-- terminate with bit skip and end --*/
	samp_dispatch[nsb_limit] = 31;
	samp_dispatch[j] = 30;
}

/* unpack scale factor */
/* combine dequant and scale factors */
static void unpack_sfL1(void)
{
	int i;

	for (i = 0; i < nbatL1; i++)
	{
		if (ballo[i])
		{
			bitget_check(6);
			cs_factorL1[i] = c_value[i] * sf_table[mac_bitget(6)];
		}
	}
}

/* unpack samples */
#define UNPACKL1_N(n) \
	s[k] = cs_factorL1[k]*(bitget(n)-((1 << (n-1)) -1));     \
	goto dispatch;
#define UNPACKL1J_N(n) \
	tmp        =  (bitget(n)-((1 << (n-1)) -1));             \
	s[k]       =  cs_factorL1[k]*tmp;                      \
	s[k+1]     =  cs_factorL1[k+1]*tmp;                    \
	k++;                                                   \
	goto dispatch;

static void unpack_sampL1()
{
   int j, k;
   float *s;
   long tmp;

   s = sample;
   for (j = 0; j < 12; j++)
   {
      k = -1;
    dispatch:
	  switch (samp_dispatch[++k])
      {
	 case 0:
	    s[k] = 0.0F;
	    goto dispatch;
	 case 1:
	    UNPACKL1_N(2)	/*  3 levels */
	 case 2:
	    UNPACKL1_N(3)	/*  7 levels */
	 case 3:
	    UNPACKL1_N(4)	/* 15 levels */
	 case 4:
	    UNPACKL1_N(5)	/* 31 levels */
	 case 5:
	    UNPACKL1_N(6)	/* 63 levels */
	 case 6:
	    UNPACKL1_N(7)	/* 127 levels */
	 case 7:
	    UNPACKL1_N(8)	/* 255 levels */
	 case 8:
	    UNPACKL1_N(9)	/* 511 levels */
	 case 9:
	    UNPACKL1_N(10)	/* 1023 levels */
	 case 10:
	    UNPACKL1_N(11)	/* 2047 levels */
	 case 11:
	    UNPACKL1_N(12)	/* 4095 levels */
	 case 12:
	    UNPACKL1_N(13)	/* 8191 levels */
	 case 13:
	    UNPACKL1_N(14)	/* 16383 levels */
	 case 14:
	    UNPACKL1_N(15)	/* 32767 levels */
/* -- joint ---- */
	 case 15 + 0:
	    s[k + 1] = s[k] = 0.0F;
	    k++;		/* skip right chan dispatch */
	    goto dispatch;
/* -- joint ---- */
	 case 15 + 1:
	    UNPACKL1J_N(2)	/*  3 levels */
	 case 15 + 2:
	    UNPACKL1J_N(3)	/*  7 levels */
	 case 15 + 3:
	    UNPACKL1J_N(4)	/* 15 levels */
	 case 15 + 4:
	    UNPACKL1J_N(5)	/* 31 levels */
	 case 15 + 5:
	    UNPACKL1J_N(6)	/* 63 levels */
	 case 15 + 6:
	    UNPACKL1J_N(7)	/* 127 levels */
	 case 15 + 7:
	    UNPACKL1J_N(8)	/* 255 levels */
	 case 15 + 8:
	    UNPACKL1J_N(9)	/* 511 levels */
	 case 15 + 9:
	    UNPACKL1J_N(10)	/* 1023 levels */
	 case 15 + 10:
	    UNPACKL1J_N(11)	/* 2047 levels */
	 case 15 + 11:
	    UNPACKL1J_N(12)	/* 4095 levels */
	 case 15 + 12:
	    UNPACKL1J_N(13)	/* 8191 levels */
	 case 15 + 13:
	    UNPACKL1J_N(14)	/* 16383 levels */
	 case 15 + 14:
	    UNPACKL1J_N(15)	/* 32767 levels */

/* -- end of dispatch -- */
	 case 31:
	    bitget_skip(bit_skip);
	 case 30:
	    s += 64;
      }				/* end switch */
   }				/* end j loop */
}


void L1table_init()
{
	int i, stepL1;

	for (stepL1 = 4, i = 1; i < 16; i++, stepL1 <<= 1) {
		look_c_valueL1[i] = (float) (2.0 / (stepL1 - 1));
	}
}

int L1decode_start()
{
	MPEG_HEADER* h = &gMpegHeader;
	int i, k, bit_code, limit;

/*- caller limit -*/
	nbatL1 = 32;
	max_sb = nbatL1;
    if(h->samplingRate != 0){
    	nsb_limit = (gDecOption.freqLimit * 64L + h->samplingRate / 2) / h->samplingRate;
    }else{
        nsb_limit = 0;
        return 0;
    }        
/*---- limit = 0.94*(32>>reduction_code);  ----*/
	limit = (32 >> gDecOption.reduction);
	if (limit > 8)
		limit--;
	if (nsb_limit > limit)
		nsb_limit = limit;
	if (nsb_limit > max_sb)
		nsb_limit = max_sb;

	if (h->mode != 3) { /* adjust for 2 channel modes */
		nbatL1 *= 2;
		max_sb *= 2;
		nsb_limit *= 2;
	}
/* set sbt function */
	bit_code = (gDecOption.convert & 8) ? 1 : 0;
	k = (h->mode == 3) ? 0 : (1 + gDecOption.convert);
	sbt = sbt_table[bit_code][gDecOption.reduction][k];//[2][3][5]

	for (i = 0; i < 768; i++)
		sample[i] = 0.0F;
	return 1;
}

IN_OUT L1decode_frame(unsigned char *bs, unsigned short *pcm)
{
	MPEG_HEADER* h = &gMpegHeader;
	IN_OUT in_out;
//    signed short *pcm = (signed short*)pcm1;
//    unsigned char *pcm = (unsigned char *)pcm1;


/* test sync */
	if ((bs[0] != 0xFF) || (bs[1] & 0xF0) != 0xF0) {
		in_out.inputSize = 0;
		in_out.outputSize = 0;
		return in_out;
	}
	h->crcDisable		= (bs[1] & 0x01);
	h->padding			= (bs[2] & 0x02) >> 1;
	h->mode				= (bs[3] & 0xc0) >> 6;
	h->modeExtension	= (bs[3] & 0x30) >> 4;
//	h->emphasis			= (bs[3] & 0x03);
	if (h->crcDisable) {
		bitget_init(bs + 4);
	}
	else {
		bitget_init(bs + 6);
	}

	stereo_sb = look_joint[(h->mode << 2) + h->modeExtension];
	unpack_baL1();		/* unpack bit allocation */
	unpack_sfL1();		/* unpack scale factor */
	unpack_sampL1();	/* unpack samples */

	sbt(sample, pcm, 12);

	in_out.inputSize = gDecInfo.minFrameSize + (h->padding << 2);
	in_out.outputSize = gDecInfo.maxOutputSize;
	return in_out;
}
