/*____________________________________________________________________________
	
        MP3 Decoder originally Copyright (C) 1995-1997 Xing Technology
        Corp.  http://www.xingtech.com
____________________________________________________________________________*/

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
	int		version;
	int		layer;
	int		crcDisable;
	int		br_index;
	int		sr_index;
	int		padding;
	int		extension;
	int		mode;
	int		modeExtension;
	int		copyright;
	int		original;
	int		emphasis;

	int		bitRate;
	int		samplingRate;
} MPEG_HEADER;

typedef struct {
	int		reduction;
	int		convert;
	int		freqLimit;
} DECODE_OPTION;

typedef struct {
	int		channels;
	int		bitsPerSample;
	int		samplingRate;
	int		minFrameSize;
	int		maxFrameSize;
	int		maxOutputSize;
} DECODE_INFO;

typedef struct {
	int		inputSize;
	int		outputSize;
} IN_OUT;

void mpegDecodeInit();
int mpegSetDecodeOption(DECODE_OPTION *option);
void mpegGetDecodeOption(DECODE_OPTION *option);

int mpegGetHeader(unsigned char *buf, int size, MPEG_HEADER *h, int *sync);
int mpegGetDecodeInfo(MPEG_HEADER *h, DECODE_INFO *info);
int mpegDecodeStart(MPEG_HEADER *h);
IN_OUT mpegDecodeFrame(unsigned char *bs, void *pcm);
void mpegDecodeReset();
int mpegSkipFrame(unsigned char *bs);

#ifdef __cplusplus
}
#endif
