/*=========================================================================
    OutputAudio Class
    for BieAmp with ID3Tag Editor
        Copyright (c) 2000-2004 Iori Ayane

    MP3 Decoder originally Copyright (C) 1995-1997 Xing Technology
    Corp.  http://www.xingtech.com
=========================================================================*/

//---------------------------------------------------------------------------
// BieAmpѽϥץ饰
#define VERSION "0.0.1"
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

//#include <fcntl.h>
//#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <esd.h>

#include "../win/win.h"
#include "outputaudio.h"


//---------------------------------------------------------------------------

/*
OutputAudio gPlugin;

extern "C" {
    __declspec(dllexport) OutputPlugin* GetInstance()
    {
	    return &gPlugin;
    }
}
*/

OutputAudio::OutputAudio()
{
  m_Esd = -1;

  m_vol_change = false;
  m_vol_left = 0;
  m_vol_right = 0;

}

OutputAudio::~OutputAudio()
{
  stop();
  close();
}

BOOL OutputAudio::open(const char* pszName, OutputInfo* pInfo)
{
  int rate = 22000;//ESD_DEFAULT_RATE;
  m_pHost = NULL;
  m_Esd = -1;
  m_Sock = -1;
  esd_format_t format = 0;
  esd_info_t *esdctl;
  
  if(pInfo == NULL){
    fprintf(stderr,"OutputAudio : pInfo is NULL.\n");
    return false;
  }
  rate = pInfo->samplingRate;
  format = ESD_STREAM | ESD_PLAY;
  switch(pInfo->channels){
  case 1:
    format |= ESD_MONO;
    break;
  case 2:
    format |= ESD_STEREO;
    break;
  default:
    fprintf(stderr,"OutputAudio : Channels\n");
    return false;
  }
  switch(pInfo->bitsPerSample){
  case 8:
    format |= ESD_BITS8;
    break;
  case 16:
    format |= ESD_BITS16;
    break;
  default:
    fprintf(stderr,"OutputAudio : bitsPerSample\n");
    return false;
  }


  /* ǥХΥץ */
  m_Esd = esd_open_sound(NULL);//m_pHost);
  if(m_Esd <= 0){
    fprintf(stderr,"OutputAudio : Not open esd!\n");
    m_Esd = -1;
    //return false;
  }
  m_Sock = esd_play_stream_fallback(format,rate,m_pHost,pszName);
  if(m_Sock <= 0){
    fprintf(stderr,"OutputAudio : Not open esd socket\n");
    m_Sock = -1;
    return false;
  }
  
  //  esdctl = esd_get_all_info(m_Esd);
  /* ݥ󥿤β */
  //esd_free_all_info(esdctl);

  //printf(">>>>>>> open wave device <<<<<<<<\n");
  return true;
}

BOOL OutputAudio::close()
{
  /* åȤΥ */
  if(m_Sock > 0){
    ::close(m_Sock);
  }
  /* ǥХΥ */
  if(m_Esd > 0){
    esd_close(m_Esd);
  }

  m_Sock = -1;
  m_Esd = -1;

  //printf(">>>>>> close wave device <<<<<<<<<\n");
  return true;
}


BOOL OutputAudio::write(const void* pData, int length)
{
  if(m_Sock <= 0){
    return false;
  }


  //ܥ塼ѹ׵᤬ޤäƤ
  if(m_vol_change == true){
     setVolume(m_vol_left,m_vol_right);
  }

  ::write(m_Sock,pData,length);

  return true;
}

BOOL OutputAudio::stop()
{
  /*
  if(m_Esd <= 0){
    return false;
  }
  */
  /*
    MMRESULT mmresult = ::waveOutReset(m_hWaveOut);
    return (mmresult == MMSYSERR_NOERROR);
  */
  return true;
}

BOOL OutputAudio::pause()
{
  if(m_Esd <= 0){
    return false;
  }

  //  esd_standby(m_Esd);
  
/*
  MMRESULT mmresult = ::waveOutPause(m_hWaveOut);
  return (mmresult == MMSYSERR_NOERROR);
*/
  return true;
}

BOOL OutputAudio::restart()
{
  if(m_Esd <= 0){
    return false;
  }

  //  esd_resume(m_Esd);
    
  return true;
}

int esd_set_stream_pan_mine( int esd, int stream_id,
			     int left_scale, int right_scale );

BOOL OutputAudio::setVolume(int left, int right)
{
  int maxVol = 256;//ܥ塼κ
  int leftV;
  int rightV;
  int proto;
  BOOL result = true;
  esd_info_t *esdctl;


  if(m_Esd <= 0){
    //ܥ塼ѹå
    m_vol_change = true;
    m_vol_left = left;
    m_vol_right = right;
    return false;
  }

  //ܥ塼ѹå
  m_vol_change = false;

  leftV	 = left * maxVol / 100;
  rightV = right * maxVol / 100;

  proto = ESD_PROTO_STREAM_PAN;
  esdctl = esd_get_all_info(m_Esd);

  if(esdctl != NULL){
    fprintf(stderr,"OutputAudio : set volume %d,%d\n",
	    leftV,esdctl->player_list->source_id);
    if(esdctl->player_list != NULL){
      if(esd_set_stream_pan_mine(m_Esd, 
				 esdctl->player_list->source_id, 
				 leftV, rightV) == -1){
	fprintf(stderr,"OutputAudio : Don't set volume.\n");
	esd_free_all_info(esdctl);
	return false;
      }
    }else{
      fprintf(stderr,"OutputAudio : Don't set volume.esdctl error.\n");
      esd_free_all_info(esdctl);
      return false;
    }
    fprintf(stderr,"OutputAudio : setted volume(%d)\n",leftV);
  }else{
    fprintf(stderr,"OutputAudio : Don't get esd info.\n");
    return false;
  }
  esd_free_all_info(esdctl);

  return true;
}

//------------------------------------------------------------------
// ƥȤesdΥĥäƤ
// Ǥ꤯Ԥʤ
// 褯ǴreadǴԤäʤʤ
//-----------------------------------------------------------------
int esd_set_stream_pan_mine( int esd, int stream_id,
			     int left_scale, int right_scale )
{
  int ok;
  int proto = ESD_PROTO_STREAM_PAN;
  
  fprintf(stderr,"esd : 0\n");
  /* send the stream panning information */
  if ( write( esd, &proto, sizeof(proto) ) != sizeof(proto) )
    return -1;
  fprintf(stderr,"esd : 1\n");
  if ( write( esd, &stream_id, sizeof(stream_id) ) != sizeof(stream_id) )
    return -1;
  fprintf(stderr,"esd : 2\n");
  if ( write( esd, &left_scale, sizeof(left_scale) ) != sizeof(left_scale) )
    return -1;
  fprintf(stderr,"esd : 3\n");
  if ( write( esd, &right_scale, sizeof(right_scale) ) != sizeof(right_scale) )
    return -1;
  fprintf(stderr,"esd : 4\n");

  /* flush the socket */
  /*
    if(fsync(esd) == -1){
    fprintf(stderr,"esd : 5 NG\n");
    }else{
    fprintf(stderr,"esd : 5 OK\n");
    }
  */

  /* read the status back from the server */
  if ( read( esd, &ok, sizeof(ok) ) != sizeof(ok) ){
    fprintf(stderr,"esd : 6 NG\n");
    return -1;
  }

  fprintf(stderr,"esd : 6 OK\n");
    
  return ok;
}

DWORD OutputAudio::getVolume(int *left,int *right)
{
  esd_info_t *esdctl;
  unsigned long vol;

  if(left == NULL || right == NULL){
    return 0;
  }

  if(m_Esd <= 0){
    *left = (int)m_vol_left;
    *right = (int)m_vol_right;
  }else{
    esdctl = esd_get_all_info(m_Esd);
    if(esdctl != NULL){
      *left = (int)(esdctl->player_list->left_vol_scale);
      *right = (int)(esdctl->player_list->right_vol_scale);
    }else{
      *left = 0;
      *right = 0;
    }
    esd_free_all_info(esdctl);

    *left = (int)(100 * *left / 256);
    *right = (int)(100 * *right / 256);
  }

  vol = 0xffff0000 & (*left << 16);
  vol |= 0x0000ffff & *right;


  return vol;
}

DWORD OutputAudio::getPosition()
{
  if(m_Esd <= 0){
    return false;
  }

  /*
    MMTIME time;

    time.wType = TIME_MS;

    waveOutGetPosition(m_hWaveOut,&time,sizeof(time));


    return time.u.ms;
  */
  return false;
}


BOOL OutputAudio::getVersion(char ver[])
{

  if(strcpy(ver,VERSION) == NULL){
    return false;
  }else{
    return true;
  }
  return false;
}

void OutputAudio::WaveProc(HWAVEOUT hWaveOut, WORD msg,DWORD instance,
			   DWORD param1, DWORD param2)
{
  switch (msg) {
  case 0://WOM_DONE:
    //OutputAudio* p = (OutputAudio*)instance;
    //::ReleaseSemaphore(p->m_hSemaphore, 1, NULL);
    break;
  }
} 
